/*!
 * @file network_stream.h
 *  implementation of a network pipe
 */

#ifndef _NETWORK_STREAM
#define _NETWORK_STREAM

#include "data_stream.h"

class Synchronizeable;
class NetworkSocket;
class ConnectionMonitor;
class NetworkProtocol;

class NetworkStream : public DataStream
{

public:
  NetworkStream();
  NetworkStream(IPaddress& address, Synchronizeable& sync, NodeType type);
  NetworkStream(Synchronizeable& sync, unsigned int port, NodeType type);

  ~NetworkStream();

  void init();

  inline bool isServer() { return (this->type == NET_SERVER)? true:false; }
  virtual void processData();

private:
   NetworkProtocol* networkProtocol;
   //NetworkSocket*       networkSockets;
   ConnectionMonitor*      connectionMonitor;
   // tList<Synchronizeable>* synchronizeables;
   Synchronizeable*         synchronizeables;
   NetworkSocket* networkSocket;
   int                    type;
};
#endif /* _NETWORK_STREAM */

